
  PROGRAM

  MAP
    MODULE('MSVCRT.DLL')
      CSIN(REAL),REAL,C,NAME('sin')
      CCOS(REAL),REAL,C,NAME('cos')
      SSE2(LONG),LONG,C,NAME('_set_sse2_enable')
    END
  END

StartT    LONG
Duration  LONG
nWidth    LONG
nHeight   LONG
PI2_128   REAL
xo        REAL
yo        REAL
x         LONG
y         LONG
nWave     LONG
 
SINarray  REAL,DIM(1200)
COSarray  REAL,DIM(1920)
COSpx     REAL
DummyReal REAL
SSE2Ret   LONG
Results   CSTRING(10000)
  CODE
  Results = ''
  StartT=CLOCK()
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
    LOOP y=1 TO nHeight
      xo += nWave * SIN(Pi2_128 * y)
      yo += nWave * COS(Pi2_128 * x)
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration with original algorithm Clarion Sin/Cos<9> ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=50 (aprox 500ms)

  StartT=CLOCK()
  SSE2Ret = SSE2(0)
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
    LOOP y=1 TO nHeight
      xo += nWave * CSIN(Pi2_128 * y)
      yo += nWave * CCOS(Pi2_128 * x)
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration w/orig.algorithm MsVCRT Sin/Cos w/SSE2=' & SSE2Ret & '<9> ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=28 (aprox 300ms)

  StartT=CLOCK()
  SSE2Ret = SSE2(1)
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
    LOOP y=1 TO nHeight
      xo += nWave * CSIN(Pi2_128 * y)
      yo += nWave * CCOS(Pi2_128 * x)
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration w/orig.algorithm MsVCRT Sin/Cos w/SSE2=' & SSE2Ret & '<9> ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=11 (aprox 100ms)

  StartT=CLOCK()
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
    COSpx = COS(Pi2_128 * x)
    LOOP y=1 TO nHeight
      xo += nWave * SIN(Pi2_128 * y)
      yo += nWave * COSpx
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration with one optimization Clarion Sin/Cos <9> ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=25 (aprox 250ms)

  StartT=CLOCK()
  LOOP nWidth*nHeight*2 TIMES
    DummyReal = SIN(0)
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration of Clarion Sin(0) stressing computation<9> ' & Duration
  !Duration=47 (aprox 500ms)

  StartT=CLOCK()
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  LOOP x=1 TO nWidth
    LOOP y=1 TO nHeight
      SINarray[y] = SIN(Pi2_128 * y)
      COSarray[x] = COS(Pi2_128 * x)
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration nested array precomputing Clarion Sin/Cos<9> ' & Duration
  !Duration=48 (aprox 500ms)

  StartT=CLOCK()
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  LOOP y=1 TO nHeight
      SINarray[y] = SIN(Pi2_128 * y)
  END
  LOOP x=1 TO nWidth
      COSarray[x] = COS(Pi2_128 * x)
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration optimized array precomput.Clarion Sin/Cos<9>  ' & Duration
  !Duration=0

  StartT=CLOCK()
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
    LOOP y=1 TO nHeight
      xo += nWave * SINarray[y]
      yo += nWave * COSarray[x]
    END
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration using previously computed Sin/Cos arrays<9>  ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=0

  StartT=CLOCK()
  nWidth = 1920
  nHeight = 1200
  Pi2_128 = 2.0 * 3.1415 / 128.0
  nWave = 15
  xo = 0
  yo = 0
  LOOP x=1 TO nWidth
      yo += nWave * COS(Pi2_128 * x) * nHeight 
  END
  LOOP y=1 TO nHeight
      xo += nWave * SIN(Pi2_128 * y) * nWidth
  END
  Duration = CLOCK()-StartT
  Results = Results & '|Duration with two optimizations Clarion Sin/Cos<9>  ' & Duration & '  xo=' & xo & '  yo=' & yo
  !Duration=0r

  SETCLIPBOARD(RESULTS)
  MESSAGE(RESULTS)
|Duration with original algorithm Clarion Sin/Cos	 50  xo=1010881.74658272  yo=-1019.1215035426
|Duration w/orig.algorithm MsVCRT Sin/Cos w/SSE2=0	 28  xo=1010881.74658272  yo=-1019.1215035426
|Duration w/orig.algorithm MsVCRT Sin/Cos w/SSE2=1	 11  xo=1010881.74658272  yo=-1019.1215035426
|Duration with one optimization Clarion Sin/Cos 	 25  xo=1010881.74658272  yo=-1019.1215035426
|Duration of Clarion Sin(0) stressing computation	 47
|Duration nested array precomputing Clarion Sin/Cos	 48
|Duration optimized array precomput.Clarion Sin/Cos	  0
|Duration using previously computed Sin/Cos arrays	  0  xo=1010881.74658272  yo=-1019.1215035426
|Duration with two optimizations Clarion Sin/Cos	  0  xo=1010881.74658392  yo=-1019.12150269282